/***************************************************************************
                          math.h  -  used by main.c to calculate the items on a stack.
                             -------------------
    begin                : Wed Oct 11 2000
    copyright            : (C) 2000 by Brian Wagener
    email                : CptanPanic@users.sourceforge.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#ifndef _CALC_H
#define _CALC_H


// Calculates string expression.
double calculate(char *);

// Converts string expression into infix stack.
struct stack strtoin(char *);

// Converts infix stack, into postfix.
struct stack intopost(struct stack *);

// Used internally to Calculates postfix expression
double calpost(struct stack *);

// Converts string operator into its corresponding enumerator value.
enum CALC_OP strtoop(const char *, char**);

double radtodeg(double);
double degtorad(double);


// Operator List in order of precedence
enum CALC_OP {
	NONE,
	LPAREN,
	RPAREN,
	PLUS,
	MINUS,
	MULTIPLY,
	DIVIDE,
	ACOS,
	COS,
	COSH,
	ASIN,
	SIN,
	SINH,
	ATAN,
	TAN,
	TANH,
	EXP,
	ABS,
	MOD,
	CEIL,
	FLOOR,
	FACT,
	LN,
	LOG,
	SQRT,
	INV,
	POWER,
	NEGATE
};


#endif
