/***************************************************************************
                          main.c  -  Used as a frontend to the calculator.
                          Reads in input, processes options, and sends info
                          to calc.c
                             -------------------
    begin                : Wed Oct 11 08:16:28 EDT 2000
    copyright            : (C) 2000 by Brian Wagener
    email                : CptanPanic@users.sourceforge.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "calc.h"
	
extern char DEGREE;
extern char VERBOSE;
extern char INT;
extern char HEX;
extern char OCT;

int parse_args(int argc, char *argv[] );

int main(int argc, char *argv[]){
	int exp;
	
	exp = parse_args(argc,argv);
	
	// Send stack to the math processor
	
	if( HEX ){
		if (INT){
			printf( "%s=0x%X\n", argv[exp], (int) calculate( argv[exp] ) );
		} else {
			printf( "%s=%a\n", argv[exp],calculate( argv[exp] ) );
		}
  } else if( OCT ){
  		if (INT){
			printf( "%s=0%o\n", argv[exp], (int) calculate( argv[exp] ) );
		} else {
			printf( "ERROR: double output of oct not available, try int.\n");
		}
	} else {
		if (INT){
			printf( "%s=%d\n", argv[exp], (int) calculate( argv[exp] ) );
		} else {
			printf( "%s=%g\n", argv[exp],calculate( argv[exp] ) );
		}
	}
  return EXIT_SUCCESS;
}

int parse_args(int argc, char *argv[] ){
	int i,j,exp = 0;
		
  if( argc == 1){
    printf("mmcalc: missing expression( \"mmcalc --help\" for help\n");
    printf("sample usage: mmcalc [options] \"1*(2.2+12.4)\"\n");
    exit(EXIT_FAILURE);
    	 	
  } else {
    for(i = 1; i < argc; i++){
      if(argv[i][0] == '-' ){
	if(argv[i][1] == '-' ){
	  // This is where we put things like --version and --help
		switch(argv[i][2]){
			case 'v':
				printf("mmcalc version: 1.0\n");
				break;
			case 'h':
				printf("mmcalc: help\n");
				printf("sample usage: mmcalc [options] \"1*(2.2+12.4)\"\n");
				printf("-h output in hex (Note hex in double is in form 0xX.Yp+Z = 0xX.Y * 2^Z\n");
				printf("-o output in integer oct\n");
				printf("-d calculations in degrees\n");
				printf("-r calculations in radians: default\n");
				printf("-i output in integer form\n");
				printf("-v verbose mode\n");
				exit(0);
				break;
		}
	}else{
	  for(j = 1 ; j < strlen(argv[i]); j++){
	    switch(argv[i][j]){
	    case 'r':
	      DEGREE = 0;
	      break;
		case 'd':
	      DEGREE = 1;
	      break;
	    case 'h':
	    	HEX = 1;
	      	break;
	    case 'o':
	      OCT = 1;
	      break;
	    case 'v':
	    	VERBOSE = 1;
	    	break;
	    case 'i':
	    	INT = 1;
	    	break;	
	    default:
	      printf("mmcalc: invalid option -- %c  Try \"mmcalc --help\" \n",argv[i][j]);
				exit(EXIT_FAILURE);
	    } // end of swich
	  } // End of for
	}
      } else {
	exp = i;
      }// end of if
    } // end of for	
  }// endif
  return exp;
}


