/***************************************************************************
                          stack.c  -  implements the stack data structure that
                          is used by calc.c.

                             -------------------
    begin                : Wed Oct 11 2000
    copyright            : (C) 2000 by Brian Wagener
    email                : CptanPanic@users.sourceforge.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "stack.h"
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

// Pushdown stack structure ------------------------------------

void stackinit(struct stack *stk){
  stk->head = (struct node *) malloc(sizeof *stk->head);
  stk->head->prev = 0;
  stk->head->next = 0;
  stk->end = stk->head;
  stk->head->data.op = 0;
  stk->head->data.num = 0;
}

struct node* push(struct stack *stk, item dat){
  struct node *new = (struct node *) malloc(sizeof *new);
  new->data = dat;
  new->prev = stk->end;
  new->data = dat;
  new->prev->next = new;
  new->next = 0;
  stk->end = new;
  return stk->end;
}

item pop(struct stack *stk){
	item dat; 	
	struct node *curr = stk->end;
		if( stk->head->next != 0){ // Make sure that it is not empty.
			dat = stk->end->data;
  			stk->end = stk->end->prev;
  			stk->end->next = 0;
  			free(curr);
  		} else {
			dat.op = -1;
			dat.num = 0;
  		}
  	return dat;
}

// Really pops the one after the head.
item pop_front(struct stack *stk){
	item dat;
	struct node *curr = stk->head->next;
	if( stk->head->next != 0){  // Make sure is not empty
  		//next copy information to be returned.
  		dat = stk->head->next->data;
  		if( curr == stk->end ){
  			stk->head->next = 0;
  		} else {
	  		stk->head->next = stk->head->next->next;
  			stk->head->next->prev = stk->head;
  		}
  		free(curr);
  	} else {
  		printf("Tried to pop and empty stack");
  		dat.op = -1;
  	}
  	return dat;
}

void stackdestroy(struct stack *stk){
  struct node *curr = stk->head;
	curr = curr->next;
	for( ; curr  != 0; curr = curr->next){
		free(curr->prev);
	}
	free(curr);
}

void dump(struct stack *stk){
	struct node *curr = stk->head;
	int i = 0;
	printf("\nExecuting Dump...\n") ;
	while( curr  != 0){
		printf("%d: op %d\n", i,  curr->data.op );
		printf("%d: num %g\n",i,curr->data.num );
		printf("-----------------\n");
		// printf( "%d: next %d\n", i, (int)curr->next );
		// printf( "%d: prev %d\n", i, (int)curr->prev );
		curr = curr->next;
		i++;
	}
}

