/***************************************************************************
                          stack.h  -  implements the stack data structure that
                          is used by calc.c.
                             -------------------
    begin                : Wed Oct 11 2000
    copyright            : (C) 2000 by Brian Wagener
    email                : CptanPanic@users.sourceforge.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef _STACK_H
#define _STACK_H

// Pushdown stack structure ------------------------------------

typedef struct {
	char op;
	long double num;
} item  ;

struct node{
	item data;
  struct node *prev;
  struct node *next;
} ;

struct stack {
	struct node *head, *end;
} ;

void stackinit(struct stack*);
 
struct node* push(struct stack* , item );

item pop(struct stack*);

item pop_front(struct stack*);

void stackdestroy(struct stack*);

void dump(struct stack*);

struct node* next(struct stack*);

enum CALC_OP parseOp(char *);

#endif

